//**********************
// OpenCV ŉ摜
//**********************

#ifdef	_WIN32
#include	<windows.h>
#include	<locale.h>
#endif

#include	<stdio.h>
#include	<malloc.h>
#include	<string.h>
#include	<time.h>

#include	"cvImgProc.h"


extern char			g_szBaseDir[260];  // fBNg
extern char			g_szWindowTitle[];  // `EBhẼ^Cgɕ\镶


cvImgProc	g_cvImgProc; // CX^X쐬


// glext.h ̋@\F֐|C^
PFNGLGENBUFFERSPROC  glGenBuffers;
PFNGLBINDBUFFERPROC  glBindBuffer;
PFNGLBUFFERDATAPROC  glBufferData;
PFNGLMAPBUFFERPROC   glMapBuffer;
PFNGLUNMAPBUFFERPROC glUnmapBuffer;


// RXgN^
cvImgProc::cvImgProc() : m_bCapturing(false), m_rec(NULL), m_pImgCam(NULL), m_pImgGray(NULL), m_pImgBin(NULL), /*m_pImgView(NULL), */ m_pImgCV(NULL)
{
}

// fXgN^
cvImgProc::~cvImgProc()
{
	if (m_rec) {
		cvReleaseVideoWriter (&m_rec); // rfIC^[̉
	}

	if (m_pImgCam) {
		cvReleaseImage (&m_pImgCam); // J摜p̃obt@J
	}
	if (m_pImgGray) {
		cvReleaseImage (&m_pImgGray); // O[摜p̃obt@J
	}
	if (m_pImgBin) {
		cvReleaseImage (&m_pImgBin); // l摜p̃obt@J
	}
#if 0
	if (m_pImgView) {
		cvReleaseImage (&m_pImgView); // OpenGL ̃r[|[g摜̃obt@J
	}
#endif
	if (m_pImgCV) {
		cvReleaseImage (&m_pImgCV); // OpenCV ̕W摜̃obt@J
	}
}


//----------------------
// 
//----------------------
void cvImgProc::init ( int nImgWidth, int nImgHeight )
{

	m_nImgWidth  = nImgWidth;  // J摜̕
	m_nImgHeight = nImgHeight; // J摜̍

	m_nWinWidth  = nImgWidth;  // OpenGL  Window ̕   ̒iKł͂Ƃ肠J摜ƓɂĂ
	m_nWinHeight = nImgHeight; // OpenGL  Window ̍


	// OpenGL ext@\̏: glutCreateWindow()̌ɂKv

	glGenBuffers = (PFNGLGENBUFFERSPROC)wglGetProcAddress("glGenBuffersARB");;
	if (glGenBuffers == NULL) {
		MessageBox (NULL, L"Not support glGenBuffersARB", L"ARTK_MMD_TWINS", MB_OK);
	}
	glBindBuffer = (PFNGLBINDBUFFERPROC)wglGetProcAddress("glBindBufferARB");;
	if (glBindBuffer == NULL) {
		MessageBox (NULL, L"Not support glBindBufferARB", L"ARTK_MMD_TWINS", MB_OK);
	}
	glBufferData = (PFNGLBUFFERDATAPROC)wglGetProcAddress("glBufferDataARB");;
	if (glBufferData == NULL) {
		MessageBox (NULL, L"Not support glBufferDataARB", L"ARTK_MMD_TWINS", MB_OK);
	}
	glMapBuffer = (PFNGLMAPBUFFERPROC)wglGetProcAddress("glMapBufferARB");;
	if (glMapBuffer == NULL) {
		MessageBox (NULL, L"Not support glMapBufferARB", L"ARTK_MMD_TWINS", MB_OK);
	}
	glUnmapBuffer = (PFNGLUNMAPBUFFERPROC)wglGetProcAddress("glUnmapBufferARB");;
	if (glUnmapBuffer == NULL) {
		MessageBox (NULL, L"Not support glUnmapBufferARB", L"ARTK_MMD_TWINS", MB_OK);
	}

	glGenBuffers (1, m_glPboId); // PBO1쐬


	/* J摜obt@p̃mۂ */
	m_pImgCam = cvCreateImage (cvSize(nImgWidth, nImgHeight), IPL_DEPTH_8U, 4); // RGBA
	if (m_pImgCam == NULL) {
		MessageBox (NULL, L"cvCreateImage error: 1", L"cvImgProc::init", MB_OK);
	}

	/* O[摜obt@p̃mۂ */
	m_pImgGray = cvCreateImage (cvSize(nImgWidth, nImgHeight), IPL_DEPTH_8U, 1); // Y
	if (m_pImgGray == NULL) {
		MessageBox (NULL, L"cvCreateImage error: 2", L"cvImgProc::init", MB_OK);
	}

	/* l摜obt@p̃mۂ */
	m_pImgBin = cvCreateImage (cvSize(nImgWidth, nImgHeight), IPL_DEPTH_8U, 1); // Y
	if (m_pImgBin == NULL) {
		MessageBox (NULL, L"cvCreateImage error: 2", L"cvImgProc::init", MB_OK);
	}
}


//--------------------------------------
// J摜AœK臒l߂
//  m_pImgCam->imageData ɃJ摜i[Ă鎖
//--------------------------------------
int cvImgProc::calcThreshold (void)
{
	cvCvtColor (m_pImgCam, m_pImgGray, CV_RGBA2GRAY); // RGBA O[摜ɐFԂϊ
	double dThresh = cvThreshold (m_pImgGray, m_pImgBin, 0, 255, CV_THRESH_BINARY | CV_THRESH_OTSU); // OpenCV ɔĂuÂ̕@v臒l߂
	
	return (int)(dThresh + 0.5);
}


//----------------------
// OpenGL  WindowTCYω
//----------------------
void cvImgProc::changeWindowSize ( int nWinWidth, int nWinHeight )
{
	m_nWinWidth  = nWinWidth;  // OpenGL  Window ̕
	m_nWinHeight = nWinHeight; // OpenGL  Window ̍
}


//----------------------
// OpenGL p timer callback ֐
//----------------------
#define TIMER_ID0  0  // Timer𓯎ɂQȏgɁAǂTimerĂяoȂ̂ʂ邽߂AAPgĂȂB
void timerCallback (int tmid)
{
	// AVIt@CփLv`
	if (g_cvImgProc.isCapturing()) {

		int iTime1 = glutGet( GLUT_ELAPSED_TIME ); // Lv`ǑoߎԁF~bP

		g_cvImgProc.capture();

		int iTime2 = glutGet( GLUT_ELAPSED_TIME ); // Lv`̌oߎԁF~bP

		// 30fps ̓t@CɂȂ悤ALv`ԂRg[
		glutTimerFunc (33 - (iTime2 - iTime1), timerCallback, TIMER_ID0); // 33msecɍēxĂяo
	} else {
		; // glutTimerFunc()ݒ肵Ȃ΁A callback ֐͌ĂяoȂȂ
	}
}


//----------------------
// AVILv`̐
//----------------------
void cvImgProc::controlCapture( void )
{
	// gO
	m_bCapturing = !m_bCapturing;

	if (m_bCapturing) {
		// Lv`Jn

		if (m_rec) {
			cvReleaseVideoWriter (&m_rec); // UArfIC^[
			m_rec = NULL;
		}
#if 0
		if (m_pImgView) {
			cvReleaseImage (&m_pImgView); // OpenGL ̃r[|[g摜̃obt@J
			m_pImgView = NULL;
		}
#endif
		if (m_pImgCV) {
			cvReleaseImage (&m_pImgCV); // OpenCV ̕W摜̃obt@J
			m_pImgCV = NULL;
		}

		char szTemp[260];
		strcpy (szTemp, g_szWindowTitle );
		strcat (szTemp, " : [[[ Capturing...]]]");
		glutSetWindowTitle( szTemp );

		// ݎ̎擾
		SYSTEMTIME st;
		::GetLocalTime(&st);

		// ۑavit@C̐FN-b-~b
		// ΃pXƁAfJ炻ɁA[VJ炻ɁAƕۑtH_Ɉړ̂ŁAŒ艻B
		sprintf(szTemp, "%s\\cap%4d%02d%02d-%02d%02d%02d-%03d.avi", g_szBaseDir, st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond, st.wMilliseconds);

//		// rfIt@C݂̐ݒ: XvidR[fBbN, 30fps
//		m_rec = cvCreateVideoWriter (szTemp, CV_FOURCC('X','V','I','D'), 30, cvSize(m_nWinWidth, m_nWinHeight));
		// rfIt@C݂̐ݒ: DivXR[fBbN, 30fps
		m_rec = cvCreateVideoWriter (szTemp, CV_FOURCC('D','I','V','X'), 30, cvSize(m_nWinWidth, m_nWinHeight));
		if (m_rec == NULL) {
			MessageBox (NULL, L"cvCreateVideoWriter error", L"cvImgProc::controlCapture", MB_OK);
		}

#if 0
		/* OpenGL ̃r[|[g摜̃TCỸmۂ */
		m_pImgView = cvCreateImage (cvSize(m_nWinWidth, m_nWinHeight), IPL_DEPTH_8U, 3);
		if (m_pImgView == NULL) {
			MessageBox (NULL, L"cvCreateImage error: 1", L"cvImgProc::controlCapture", MB_OK);
		}
#endif

		// OpenCV ̕W摜tH[}bg(BGR888)̃obt@mۂ
		m_pImgCV = cvCreateImage (cvSize(m_nWinWidth, m_nWinHeight), IPL_DEPTH_8U, 3);
		if (m_pImgCV == NULL) {
			MessageBox (NULL, L"cvCreateImage error: 2", L"cvImgProc::controlCapture", MB_OK);
		}

		// OpenGL PBO oCh
		glBindBuffer (GL_PIXEL_PACK_BUFFER_ARB, m_glPboId[0]);
		glBufferData (GL_PIXEL_PACK_BUFFER_ARB, m_nWinWidth * m_nWinHeight * 4, 0, GL_STREAM_READ_ARB);
		glBindBuffer (GL_PIXEL_PACK_BUFFER_ARB, 0);

		// Lv`Jn
		glutTimerFunc (0, timerCallback, TIMER_ID0); // timer callback ֐Ăяo

	} else {
		// Lv`~
		glutSetWindowTitle( g_szWindowTitle );

		if (m_rec) {
			cvReleaseVideoWriter (&m_rec); // rfIC^[̉
			m_rec = NULL;
		}
#if 0
		if (m_pImgView) {
			cvReleaseImage (&m_pImgView); // OpenGL ̃r[|[g摜̃obt@J
			m_pImgView = NULL;
		}
#endif
		if (m_pImgCV) {
			cvReleaseImage (&m_pImgCV); // OpenCV ̕W摜̃obt@J
			m_pImgCV = NULL;
		}
	}
}


//----------------------
// ݂ OpenGL 摜ɂ AVILv`s
//----------------------
bool cvImgProc::capture( void )
{
	if (m_pImgCV) {

#if 0
		// OpenGL ̉摜obt@Rs[: _ (Windows BitmapƓ)
//		glReadPixels (0, 0, m_nWinWidth, m_nWinHeight, GL_RGB, GL_UNSIGNED_BYTE, m_pImgView->imageData);
		glReadPixels (0, 0, m_nWinWidth, m_nWinHeight, GL_BGR, GL_UNSIGNED_BYTE, m_pImgCV->imageData); // BGȐœǂݍ߂

//		cvConvertImage (m_pImgView, m_pImgCV, CV_CVTIMG_FLIP | CV_CVTIMG_SWAP_RB); // RGB̏œǂݍ񂾏ꍇ͏㉺]R/Bւ𓯎ɍs
		cvFlip (m_pImgCV, m_pImgCV, 0); // ㉺]

#else

		// ݂̃t[obt@PBOɃRs[
		glBindBuffer (GL_PIXEL_PACK_BUFFER_ARB, m_glPboId[0]);
		glReadPixels (0, 0, m_nWinWidth, m_nWinHeight, GL_RGBA, GL_UNSIGNED_BYTE, 0); // RGBA

		GLubyte *pImgTop = (GLubyte *) glMapBuffer (GL_PIXEL_PACK_BUFFER_ARB, GL_READ_ONLY_ARB); // }bsO:ǂݍ݂̂

		if (pImgTop) {

			// RGBA  BRG ɕϊȂAXɉ摜㉺𔽓]
			for (int y = 0; y < m_nWinHeight; y++) {
				GLubyte *src = &pImgTop[(m_nWinHeight - 1 - y) * m_nWinWidth * 4]; // OpenGL ́̕A֏
				uchar   *dst = (uchar *)(m_pImgCV->imageData + m_pImgCV->widthStep * y); // OpenCV ́̕Aォ牺
				for (int x = 0; x < m_nWinWidth; x++) {
					*dst++ = src[2]; // B
					*dst++ = src[1]; // G
					*dst++ = src[0]; // R
					src += 4; // Â͎Ă
				}
			}
			
			glUnmapBuffer (GL_PIXEL_PACK_BUFFER_ARB); // }bsO
		}

		glBindBuffer (GL_PIXEL_PACK_BUFFER_ARB, 0);

#endif

		cvWriteFrame (m_rec, m_pImgCV);  // rfIC^[ 1t[
	}

	return true;
}

