//**********************
// OpenCV ŉ摜
//**********************

#ifndef __CVIMGPROC_H__
#define __CVIMGPROC_H__


#include	<gl/glut.h>
#include	<gl/glext.h>

#include	<opencv2/opencv.hpp>

//-------------------------------
// OpenCV 2.4.6 gp
//-------------------------------
#pragma comment(lib, "opencv_imgproc246.lib")
#pragma comment(lib, "opencv_core246.lib")
#pragma comment(lib, "opencv_highgui246.lib")



class cvImgProc
{
private:
	
	bool			m_bCapturing;  // AVIƂăLv`邩ǂ
	int				m_nImgWidth;  // J摜̕
	int				m_nImgHeight; // J摜̍
	int				m_nWinWidth;  // OpenGL  Window ̕
	int				m_nWinHeight; // OpenGL  Window ̍
	CvVideoWriter	*m_rec;       // OpenCV rfIC^[錾

	IplImage		*m_pImgCam;  // RGBA: J摜p̃obt@
	IplImage		*m_pImgGray; // Y: O[摜p̃obt@
	IplImage		*m_pImgBin;  // Y: l摜p̃obt@
//	IplImage		*m_pImgView; // RGBA: OpenGL ̃r[|[g摜ǂݎׂ̃obt@
	IplImage		*m_pImgCV;   // BGR:   OpenCV ̕W摜tH[}bg̃obt@

	GLuint			m_glPboId[1]; // OpenGL PBOpID

public:
	cvImgProc();
	~cvImgProc();

	void init ( int nImgWidth, int nImgHeight ); // 

	inline char * getImgCamBuff (void) { return m_pImgCam->imageData; } // J摜p̃obt@
	int calcThreshold (void); // J摜AœK臒l߂

	void changeWindowSize( int nWinWidth, int nWinHeight ); // OpenGL  WindowTCYω
	inline int  getWinWidth (void) { return m_nWinWidth;  }  // OpenGL  Window ̕
	inline int  getWinHeight(void) { return m_nWinHeight; }  // OpenGL  Window ̍

	void controlCapture( void ); // AVILv`̐

	inline bool isCapturing(void) { return m_bCapturing; } // Lv`H

	bool capture( void ); // ݂ OpenGL 摜ɂ AVILv`s

};


extern cvImgProc g_cvImgProc;


#endif // __CVIMGPROC_H__

